"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: November 06, 2023,
Version: 1.0.0
Description: Database of the expert system
"""

import BazeZnalosti

# All windows
windows = [
    BazeZnalosti.Window("window1", "LivingRoom1", 1500, 1600, "North", "Plastic", "White"),
    BazeZnalosti.Window("window2", "LivingRoom1", 1000, 800, "North", "PVC", "Beige"),
    BazeZnalosti.Window("window3", "Kitchen1", 1500, 1200, "North", "Wood", "White"),
    BazeZnalosti.Window("window4", "Kitchen1", 1200, 1000, "West", "Wood", "Natural"),
    BazeZnalosti.Window("window5", "Kitchen1", 800, 800, "West", "Plastic", "Blue"),
    BazeZnalosti.Window("window6", "KidsRoom1", 1000, 800, "East", "Plastic", "Gray"),
    BazeZnalosti.Window("window7", "KidsRoom1", 600, 600, "South", "Vinyl", "Silver"),
    BazeZnalosti.Window("window8", "Bedroom1", 700, 700, "East", "Plastic", "White"),
    BazeZnalosti.Window("window9", "Hall1", 1200, 1000, "South", "Aluminum", "Bronze"),
]

# All doors
doors = [
    BazeZnalosti.Door("door1", "Hall1", "LivingRoom1", 2100, 900, "Wood", "Brown"),
    BazeZnalosti.Door("door2", "Hall1", "Kitchen1", 2100, 900, "Wood", "Brown"),
    BazeZnalosti.Door("door3", "Hall1", "Bedroom1", 2000, 800, "Wood", "White"),
    BazeZnalosti.Door("door4", "Hall1", "KidsRoom1", 2100, 900, "Glass", "Clear"),
    BazeZnalosti.Door("door5", "Hall1", "Bathroom1", 2100, 900, "Metal", "Silver"),
    BazeZnalosti.Door("door6", "Hall1", "Toilet1", 2000, 800, "PVC", "White"),
    BazeZnalosti.Door("door7", "Hall1", "outside", 2000, 800, "Metal", "Brown"),
    BazeZnalosti.Door("door8", "LivingRoom1", "Kitchen1", 2100, 900, "Glass", "Tinted"),
    BazeZnalosti.Door("door9", "Kitchen1", "Bedroom1", 2100, 900, "PVC", "Beige"),
    BazeZnalosti.Door("door10", "Bedroom1", "KidsRoom1", 2100, 900, "Wood", "Mahogany"),
    BazeZnalosti.Door("door11", "Bedroom1", "Bathroom1", 2200, 1000, "Steel", "White"),
]

# Doors what are in living room
doors_living_room = [
    doors[0],
    doors[7],
]

# Doors what are in bedroom
doors_bedroom = [
    doors[2],
    doors[8],
    doors[9],
    doors[10],
]

# Doors what are in kids room
doors_kids_room = [
    doors[3],
    doors[9],
]

# Doors what are in kitchen
doors_kitchen = [
    doors[1],
    doors[8],
]

# Doors what are in bathroom
doors_bathroom = [
    doors[4],
    doors[10],
]

# All furniture
furniture = [
    BazeZnalosti.Furniture("Sofa1", "LivingRoom1", "Sofa", "near wall"),
    BazeZnalosti.Furniture("Table1", "LivingRoom1", "Table", "in the center"),
    BazeZnalosti.Furniture("Chair1", "Kitchen1", "Chair", "by the window"),
    BazeZnalosti.Furniture("Bed1", "Bedroom1", "Bed", "in the corner"),
    BazeZnalosti.Furniture("Desk1", "Bedroom1", "Desk", "against the wall"),
    BazeZnalosti.Furniture("Wardrobe1", "Bedroom1", "Wardrobe", "in the center"),
    BazeZnalosti.Furniture("Dresser1", "KidsRoom1", "Dresser", "near wall"),
    BazeZnalosti.Furniture("Bookshelf1", "LivingRoom1", "Bookshelf", "in the center"),
    BazeZnalosti.Furniture("Couch1", "LivingRoom1", "Couch", "against the wall"),
    BazeZnalosti.Furniture("DiningTable1", "Kitchen1", "Dining Table", "near wall"),
    BazeZnalosti.Furniture("Sink1", "Bathroom1", "Sink", "in the center"),
    BazeZnalosti.Furniture("Bathtub1", "Bathroom1", "Bathtub", "by the window"),
    BazeZnalosti.Furniture("Shower1", "Bathroom1", "Shower", "in the corner"),
    BazeZnalosti.Furniture("Chair2", "Bedroom1", "Chair", "in the corner"),
    BazeZnalosti.Furniture("Bed2", "KidsRoom1", "Bed", "against the wall"),
    BazeZnalosti.Furniture("Table2", "Hall1", "Table", "near wall"),
    BazeZnalosti.Furniture("Desk2", "KidsRoom1", "Desk", "in the center"),
    BazeZnalosti.Furniture("Bookshelf2", "LivingRoom1", "Bookshelf", "against the wall"),
    BazeZnalosti.Furniture("Chair3", "KidsRoom1", "Chair", "near wall"),
    BazeZnalosti.Furniture("Toilet1", "Toilet1", "Toilet", "near wall")
]

# All furniture in living room
furniture_living_room = [
    furniture[0],
    furniture[1],
    furniture[7],
    furniture[8],
    furniture[17],
]

# All furniture in bedroom
furniture_bedroom = [
    furniture[3],
    furniture[4],
    furniture[5],
    furniture[13],
]

# All furniture in kids room
furniture_kids_room = [
    furniture[6],
    furniture[14],
    furniture[16],
    furniture[18],
]

# All furniture in kitchen
furniture_kitchen = [
    furniture[2],
    furniture[9],
]

# All furniture in bathroom
furniture_bathroom = [
    furniture[10],
    furniture[11],
    furniture[12],
]

# All elecrotnic devices
electric_devices = [
    BazeZnalosti.Electric_device("Television1", "LivingRoom1", "Television", "LG", 300, "Against the wall"),
    BazeZnalosti.Electric_device("Laptop1", "KidsRoom1", "Laptop", "Dell", 90, "On the desk"),
    BazeZnalosti.Electric_device("Refrigerator1", "Kitchen1", "Refrigerator", "Samsung", 600, "By the corner"),
    BazeZnalosti.Electric_device("WashingMachine1", "Bathroom1", "Washing Machine", "Whirlpool", 400, "Near the sink"),
    BazeZnalosti.Electric_device("Microwave1", "Kitchen1", "Microwave", "Panasonic", 1000, "On the countertop"),
    BazeZnalosti.Electric_device("CoffeeMaker1", "Kitchen1", "Coffee Maker", "Keurig", 1200, "Beside the toaster"),
    BazeZnalosti.Electric_device("AirConditioner1", "LivingRoom1", "Air Conditioner", "Carrier", 1500,
                                 "Near the window"),
    BazeZnalosti.Electric_device("VacuumCleaner1", "LivingRoom1", "Vacuum Cleaner", "Dyson", 1000, "In the closet"),
    BazeZnalosti.Electric_device("DesktopComputer1", "Bedroom1", "Computer", "HP", 350, "On the desk"),
    BazeZnalosti.Electric_device("Toaster1", "Kitchen1", "Toaster", "Cuisinart", 800, "Against the wall"),
    BazeZnalosti.Electric_device("Heater1", "Bedroom1", "Heater", "Honeywell", 1500, "By the bed"),
    BazeZnalosti.Electric_device("Fan1", "Bedroom1", "Fan", "Hunter", 75, "By the window"),
    BazeZnalosti.Electric_device("Blender1", "Kitchen1", "Blender", "Vitamix", 1000, "On the countertop"),
    BazeZnalosti.Electric_device("Smartphone1", "KidsRoom1", "Smartphone", "Apple", 10, "On the nightstand"),
    BazeZnalosti.Electric_device("GamingConsole1", "LivingRoom1", "Gaming Console", "Sony", 150, "Under the TV"),
    BazeZnalosti.Electric_device("Radio1", "KidsRoom1", "Radio", "Sony", 50, "On the shelf"),
    BazeZnalosti.Electric_device("Oven1", "Kitchen1", "Oven", "Whirlpool", 2200, "In the kitchen"),
    BazeZnalosti.Electric_device("ElectricToothbrush1", "Bathroom1", "Electric Toothbrush", "Oral-B", 15,
                                 "Near the sink"),
    BazeZnalosti.Electric_device("Lamp1", "Bedroom1", "Lamp", "IKEA", 20, "Beside the bed"),
    BazeZnalosti.Electric_device("Lamp2", "LivingRoom1", "Lamp", "Philips", 25, "By the sofa")
]

# All devices in living room
devices_living_room = [
    electric_devices[0],
    electric_devices[6],
    electric_devices[7],
    electric_devices[14],
    electric_devices[19],
]

# All devices in kitchen
devices_kitchen = [
    electric_devices[2],
    electric_devices[4],
    electric_devices[5],
    electric_devices[9],
    electric_devices[12],
    electric_devices[16],
]

# All devices in kids room
devices_kids_room = [
    electric_devices[1],
    electric_devices[13],
    electric_devices[15],
]

# All devices in bedroom
devices_bedroom = [
    electric_devices[8],
    electric_devices[10],
    electric_devices[11],
    electric_devices[18],
]

# All devices in bathroom
devices_bathroom = [
    electric_devices[3],
    electric_devices[17],
]

# All rooms
rooms = [
    BazeZnalosti.Room("Hall1", "Flat1", "Hall", 6, "2x3", "Tiles", [windows[8]], doors[0:6], [furniture[15]], []),
    BazeZnalosti.Room("LivingRoom1", "Flat1", "Living Room", 25, "5x5", "Hardwood", windows[0:1], doors_living_room,
                      furniture_living_room, devices_living_room),
    BazeZnalosti.Room("Bedroom1", "Flat1", "Bedroom", 15, "3x5", "Carpet", [windows[7]], doors_bedroom,
                      furniture_bedroom, devices_bedroom),
    BazeZnalosti.Room("Kitchen1", "Flat1", "Kitchen", 12, "4x3", "Tile", windows[2:4], doors_kitchen, furniture_kitchen,
                      devices_kitchen),
    BazeZnalosti.Room("Bathroom1", "Flat1", "Bathroom", 6, "2x3", "Ceramic", [], doors_bathroom, furniture_bathroom,
                      devices_bathroom),
    BazeZnalosti.Room("Toilet1", "Flat1", "Toilet", 2, "1x2", "Hardwood", [], [doors[5]], [furniture[19]], []),
    BazeZnalosti.Room("KidsRoom1", "Flat1", "Kids room", 10, "2x5", "Laminate", windows[5:6], doors_kids_room,
                      furniture_kids_room, devices_kids_room)
]

# All flats
flats = [
    BazeZnalosti.Flat("Flat1", "Kralovska 123, Praha 1, 110 00, Czechia", 3, "Petr Beck", 76, "3+1", rooms)
]

# Type of electronic devices
device_types = ["Lamp", "Fan", "Refrigerator", "Washing Machine", "Microwave", "Oven", "Computer", "Air Conditioner",
                "Television", "Laptop", "Toaster", "Electric toothbrush", "Radio", "Gaming Console", "Heater",
                "Blender",
                "Vacuum Cleaner", "Coffee Maker"]

# Room types
room_types = ["Living Room", "Kitchen", "Bedroom", "Kids room", "Bathroom", "Toilet", "Office", "Dinning room", "Hall"]

furniture_types = ["Sofa", "Table", "Chair", "Bed", "Desk", "Wardrobe", "Dresser", "Bookshelf", "Couch", "Dining Table",
                   "Sink", "Bathtub", "Shower", "Couch"]

# Directions
directions = ["North", "South", "East", "West"]

# All possible frames
frames = ["Flat", "Room", "Window", "Door", "Furniture", "Device", "All"]
