"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-11-27
Program: Baze znalosti
Verze: 1.0.0
"""

# baze dat
import baze_dat as bd


# vytvori odpoved na info o byte
def odpoved_info_byt():
    odpoved = "Informace o bytě:\n"
    for key, value in bd.byt.items():
        if key == "místnosti" or key == "is-a":
            continue
        odpoved += key + ": " + value + "\n"
    return odpoved


# vytvori odpoved na mistnosti
def odpoved_mistnosti():
    odpoved = "Místnosti:\n"
    for key in bd.byt["místnosti"].keys():
        odpoved += key + "\n"
    return odpoved


# kontroluje vstup
def kontrola_vstupu(mistnost):
    for key in bd.byt["místnosti"].keys():
        if key == mistnost:
            return 0
    return 1


# vytvori odpoved na info o mistnosti
def odpoved_info_mistnost(mistnost):
    odpoved = "Informace o místnosti - " + mistnost + ":\n"
    ramec_mistnosti = {}
    for key, value in bd.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnosti = value
            break
    for key, value in ramec_mistnosti.items():
        if key == "okna" or key == "is-a" or key == "nábytek" or key == "dveře":
            continue
        odpoved += key + ": " + value + "\n"
    return odpoved


# vytvori odpoved na nabytek v mistnosti
def odpoved_nabytek(mistnost):
    odpoved = "Nábytek v místnosti - " + mistnost + ":\n"
    ramec_mistnosti = {}
    for key, value in bd.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnosti = value
            break
    for value in ramec_mistnosti["nábytek"]:
        odpoved += value + "\n"
    return odpoved


# vytvori odpoved na pocet oken v mistnosti
def odpoved_pocet_oken(mistnost):
    odpoved = "Počet oken v místnosti - " + mistnost + ": "
    ramec_mistnosti = {}
    for key, value in bd.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnosti = value
            break
    odpoved += str(len(ramec_mistnosti["okna"])) + "\n"
    return odpoved


# vytvori odpoved na to kam se lze z mistnosti dostat
def odpoved_kam(mistnost):
    odpoved = "Z místnosti - " + mistnost + ", se dostanu do:\n"
    ramec_mistnosti = {}
    for key, value in bd.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnosti = value
            break


# vytvori odpoved na info o oknech v mistnosti
def odpoved_info_okna(mistnost):
    odpoved = ""
    i = 1
    ramec_mistnosti = {}
    for key, value in bd.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnosti = value
            break
    odpoved += "Počet oken v místnosti - " + mistnost + ": " + str(len(ramec_mistnosti["okna"])) + "\n"
    for okno in ramec_mistnosti["okna"]:
        odpoved += str(i) + ". okno:\n"
        i = i + 1
        for key, value in okno.items():
            if key == "is-a":
                continue
            odpoved += key + ": " + value + "\n"
    return odpoved


# vytvori odpoved na info o dverich v mistnosti
def odpoved_info_dvere(mistnost):
    odpoved = ""
    i = 1
    ramec_mistnosti = {}
    for key, value in bd.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnosti = value
            break
    odpoved += "Počet dveří v místnosti - " + mistnost + ": " + str(len(ramec_mistnosti["dveře"])) + "\n"
    for dvere in ramec_mistnosti["dveře"]:
        odpoved += str(i) + ". dveře:\n"
        i = i + 1
        for key, value in dvere.items():
            if key == "is-a":
                for kam in value:
                    if kam != mistnost:
                        odpoved += "vedou do místnosti: " + kam + "\n"
                continue
            odpoved += key + ": " + value + "\n"
    return odpoved
