"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-11-27
Program: Inferencni mechanismus
Verze: 1.0.0
"""

# komunikacni modul
import komunikacni_modul as km
# baze znalosti
import baze_znalosti as bz


# hlavni metoda programu
def spustit():
    # vypise uvod
    km.vypis_uvod()
    # vypise pomoc
    km.vypis_pomoc()

    pokracuj = True
    # dokud uzivatel nezada konec
    while pokracuj:
        zprava = km.vstup()
        # kdyz uzivatel zada konec
        if zprava == "k" or zprava == "K":
            pokracuj = False
        # vypise pomoc
        elif zprava == "":
            km.vypis_pomoc()
        # vypise odpoved na info o byte
        elif zprava == "1":
            km.odpoved(bz.odpoved_info_byt())
        # vypise odpoved na mistnosti
        elif zprava == "2":
            km.odpoved(bz.odpoved_mistnosti())
        # slozitejsi prikaz
        elif len(zprava.split()) == 2:
            casti_zpravy = zprava.split()
            # kontrola zadane zpravy
            if bz.kontrola_vstupu(casti_zpravy[1]):
                km.spatny_vstup()
            else:
                # vypise odpoved na info o mistnosti
                if casti_zpravy[0] == "3":
                    km.odpoved(bz.odpoved_info_mistnost(casti_zpravy[1]))
                # vypise odpoved na nabytek v mistnosti
                elif casti_zpravy[0] == "4":
                    km.odpoved(bz.odpoved_nabytek(casti_zpravy[1]))
                # vypise odpoved na pocet oken v mistnosti
                elif casti_zpravy[0] == "5":
                    km.odpoved(bz.odpoved_pocet_oken(casti_zpravy[1]))
                # vypise odpoved na to kam se lze dostat z mistnosti
                elif casti_zpravy[0] == "6":
                    km.odpoved(bz.odpoved_kam(casti_zpravy[1]))
                # vypise odpoved na info o oknech v mistnosti
                elif casti_zpravy[0] == "7":
                    km.odpoved(bz.odpoved_info_okna(casti_zpravy[1]))
                # vypise info o dverich v mistnosti
                elif casti_zpravy[0] == "8":
                    km.odpoved(bz.odpoved_info_dvere(casti_zpravy[1]))
        # spatne zadana sprava
        else:
            km.spatny_vstup()
    # vypise konec
    km.konec()
