"""
autor: Miroslav Martinek
datum: 17.11.2023
zadani 06
Baze znalosti systemu.
"""
import baze_dat


# vraci seznam sousedicich mistnosti jako retezec
def connected_rooms(room):
    rooms = ""
    found = baze_dat.byt["mistnosti"].get(room)
    if (found == None):
        return None
    for door in found["dvere"]:
        door_rooms = found["dvere"][door]["is-a"]
        for x in door_rooms:
            if(x != room):
                rooms += x + ";"
    return rooms


# vraci informace z ramce jako retezec
def info(target):
    relevant_info = ""
    for key, val in target.items():
        if(key == "is-a"):
            continue
        elif(isinstance(val, str)):
            relevant_info += key + ": " + val + "\n"
        else:
            relevant_info += key + ": "
            for inner_key in val.keys():
                relevant_info += inner_key + ";"
            relevant_info += "\n"

    return relevant_info


# ziska a vrati informace o bytu
def get_byt_info():
    return info(baze_dat.byt)


# ziska a vrati informace o mistnosti
def get_room_info(room):
    found = baze_dat.byt["mistnosti"].get(room)
    if(found == None):
        return None
    return info(found)


# ziska a vrati informace o vybaveni(okna, dvere, nabytek, spotrebice)
def get_item_info(room_name, item):
    room = baze_dat.byt["mistnosti"].get(room_name)
    if (room == None):
        return "1"  # mistnost neexistuje
    found = room["okna"].get(item)
    if (found != None):
        return info(found)
    found = room["dvere"].get(item)
    if (found != None):
        return info(found)
    found = room["nabytek"].get(item)
    if (found != None):
        return info(found)
    found = room["spotrebice"].get(item)
    if (found != None):
        return info(found)
    return "2"  # kus vybaveni neexistuje
