"""
Description: Tento modul ukládá a poskytuje znalosti.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 13.11.2023
"""
from baze_dat import rooms, doors, windows, objects, positions


# ramec reprezentujici byt
class FlatFrame:
    def __init__(self, is_in, address, floor, owner, size, flat_type, rooms):
        self.is_in = is_in
        self.address = address
        self.floor = floor
        self.owner = owner
        self.size = size
        self.flat_type = flat_type
        self.rooms = rooms


# ramec reprezentujici mistnosti
class RoomFrame:
    def __init__(self, name, is_in, size, dimensions, flooring, windows, doors, furniture, electrical_appliances):
        self.name = name
        self.is_in = is_in
        self.size = size
        self.dimensions = dimensions
        self.flooring = flooring
        self.windows = windows
        self.doors = doors
        self.furniture = furniture
        self.electrical_appliances = electrical_appliances


# ramec reprezentujici okna
class WindowFrame:
    def __init__(self, name, is_in, window_type, dimensions, position, color):
        self.name = name
        self.is_in = is_in
        self.window_type = window_type
        self.dimensions = dimensions
        self.position = position
        self.color = color


# ramec reprezentujici dvere
class DoorFrame:
    def __init__(self, name, is_in, door_type, dimensions, position, color):
        self.name = name
        self.is_in = is_in
        self.door_type = door_type
        self.dimensions = dimensions
        self.position = position
        self.color = color


# ramec reprezentujici objekty
class ObjectFrame:
    def __init__(self, is_in, object_type, position):
        self.is_in = is_in
        self.object_type = object_type
        self.position = position


flat_frame = FlatFrame("panelák", "Olomouc, Dlouhá 45, 77900", 4, "Novák Jan", 110, "4+1", rooms)

room_frames = [RoomFrame(rooms[0], "byt", 15, "3x5", "dlaždice", [windows[0]], [doors[0], doors[1], doors[2]],  # kuchyne
               [objects[4], objects[8]], [objects[12]]),
               RoomFrame(rooms[1], "byt", 20, "4x5", "dlaždice", [], [doors[0], doors[3]],  # jidelna
               [objects[4], objects[6], objects[7]], []),
               RoomFrame(rooms[2], "byt", 16, "4x4", "parkety", [windows[1], windows[2]], [doors[2], doors[4]],  # obyvak
               [objects[3]], [objects[10], objects[9]]),
               RoomFrame(rooms[3], "byt", 20, "5x4", "parkety", [windows[3]], [doors[5]],  # loznice
               [objects[0], objects[1], objects[2]], []),
               RoomFrame(rooms[4], "byt", 16, "4x4", "parkety", [windows[4]], [doors[6]],  # pokoj
               [objects[5]], [objects[11]]),
               RoomFrame(rooms[5], "byt", 12, "2x6", "dlaždice", [], [doors[3], doors[5], doors[6], doors[7]],  # predsin
               [], []),
               RoomFrame(rooms[6], "byt", 15, "3x5", "dlaždice", [], [doors[1]],  # koupelna
               [objects[13]], []),
               RoomFrame(rooms[7], "byt", 6, "3x2", "dlaždice", [], [doors[7]],  # WC
               [objects[14]], [])]

window_frames = [WindowFrame(windows[0], rooms[0], "plastové okno", "2x2", positions[0], "bílá"),
                 WindowFrame(windows[1], rooms[2], "plastové okno", "2x2", positions[3], "bílá"),
                 WindowFrame(windows[2], rooms[2], "plastové okno", "2x2", positions[0], "bílá"),
                 WindowFrame(windows[3], rooms[3], "plastové okno", "2x2", positions[2], "bílá"),
                 WindowFrame(windows[4], rooms[4], "plastové okno", "2x2", positions[1], "bílá")]

door_frames = [DoorFrame(doors[0], [rooms[0], rooms[1]], "dvoukřídlé", "2x2", positions[1], "hnědá"),
               DoorFrame(doors[1], [rooms[0], rooms[6]], "jednokřídlé", "1x2", positions[2], "bílá"),
               DoorFrame(doors[2], [rooms[0], rooms[2]], "jednokřídlé", "1x2", positions[3], "hnědá"),
               DoorFrame(doors[3], [rooms[1], rooms[5]], "jednokřídlé", "1x2", positions[1], "hnědá"),
               DoorFrame(doors[4], [rooms[2], rooms[4]], "jednokřídlé", "1x2", positions[1], "hnědá"),
               DoorFrame(doors[5], [rooms[3], rooms[5]], "jednokřídlé", "1x2", positions[3], "hnědá"),
               DoorFrame(doors[6], [rooms[4], rooms[5]], "jednokřídlé", "1x2", positions[2], "hnědá"),
               DoorFrame(doors[7], [rooms[5], rooms[7]], "jednokřídlé", "1x2", positions[0], "bílá")]

object_frames = [ObjectFrame([rooms[3]], objects[0], positions[0]),
                 ObjectFrame([rooms[3]], objects[1], positions[1]),
                 ObjectFrame([rooms[3]], objects[2], positions[4]),
                 ObjectFrame([rooms[2]], objects[3], positions[3]),
                 ObjectFrame([rooms[0], rooms[1]], objects[4], positions[5]),
                 ObjectFrame([rooms[4]], objects[5], positions[5]),
                 ObjectFrame([rooms[1]], objects[6], positions[2]),
                 ObjectFrame([rooms[1]], objects[7], positions[0]),
                 ObjectFrame([rooms[0]], objects[8], positions[4]),
                 ObjectFrame([rooms[2]], objects[9], positions[3]),
                 ObjectFrame([rooms[2]], objects[10], positions[5]),
                 ObjectFrame([rooms[4]], objects[11], positions[4]),
                 ObjectFrame([rooms[0]], objects[12], positions[0]),
                 ObjectFrame([rooms[6]], objects[13], positions[2]),
                 ObjectFrame([rooms[7]], objects[14], positions[0])]
