# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 11. 11. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k ukladani znalosti o datech,
# ktera jsou jiz definovana prevazne v bazi dat.
# ------------------------------------------------------------------------------------------------
import komunikacni_modul

INDEX_KUCHYNE = INDEX_OKNO_1 = INDEX_DVERE_1 = INDEX_SKRIN = UMISTENI_POD_OKNEM = 0
INDEX_JIDELNA = INDEX_OKNO_2 = INDEX_DVERE_2 = INDEX_POSTEL = UMISTENI_U_DVERI = 1
INDEX_OBYVAK = INDEX_OKNO_3 = INDEX_DVERE_3 = INDEX_NOCNI_STOLEK = UMISTENI_NAPROTI_OKNU = 2
INDEX_LOZNICE = INDEX_OKNO_4 = INDEX_DVERE_4 = INDEX_VAZA = UMISTENI_NAPROTI_DVERIM = 3
INDEX_POKOJ = INDEX_OKNO_5 = INDEX_DVERE_5 = INDEX_LUSTR = UMISTENI_U_SEVERNI_STENY = 4
INDEX_PREDSIN = INDEX_OKNO_6 = INDEX_DVERE_6 = INDEX_KOBEREC = UMISTENI_U_JIZNI_STENY = 5
INDEX_KOUPELNA = INDEX_DVERE_7 = INDEX_STUL = UMISTENI_U_VYCHODNI_STENY = 6
INDEX_WC = INDEX_DVERE_8 = INDEX_ZIDLE = UMISTENI_U_ZAPADNI_STENY = 7
INDEX_GARAZ = INDEX_POLICKA = 8
INDEX_TELEVIZE = 9
INDEX_LAMPA = 10
INDEX_POCITAC = 11
INDEX_RADIO = 12
INDEX_UMYVADLO = 13
INDEX_ZACHODOVA_MISA = 14
INDEX_KANYSTR = 14

mistnosti = komunikacni_modul.ziskej_mistnosti()
okna = komunikacni_modul.ziskej_okna()
dvere = komunikacni_modul.ziskej_dvere()
objekty_v_mistnosti = komunikacni_modul.ziskej_objekty_v_mistnosti()
umisteni = komunikacni_modul.ziskej_umisteni()


# tento ramec reprezentuje byt
class BytovyRamec:
    def __init__(self, is_a, adresa, patro, majitel, velikost, typ, obsahuje_mistnosti):
        self.is_a = is_a
        self.adresa = adresa
        self.patro = patro
        self.majitel = majitel
        self.velikost = velikost  # v m^2
        self.typ = typ
        self.mistnosti = obsahuje_mistnosti


# ramec reprezentujici mistnost
class RamecMistnosti:
    def __init__(self, jmeno, is_a, velikost, rozmery, podlaha, okna, dvere, nabytek, elektrospotrebice):
        self.jmeno = jmeno
        self.is_a = is_a
        self.velikost = velikost
        self.rozmery = rozmery
        self.podlaha = podlaha
        self.okna = okna
        self.dvere = dvere
        self.nabytek = nabytek
        self.elektrospotrebice = elektrospotrebice


# reprezentuje okno
class OkenniRamec:
    def __init__(self, jmeno, is_a, typ, rozmer, poloha, barva_ramu):
        self.jmeno = jmeno
        self.is_a = is_a
        self.typ = typ
        self.rozmer = rozmer
        self.poloha = poloha
        self.barva_ramu = barva_ramu


# ramec reprezentujici dvere
class DverniRamec:
    def __init__(self, jmeno, is_a, typ, rozmer, poloha, barva):
        self.jmeno = jmeno
        self.is_a = is_a
        self.typ = typ
        self.rozmer = rozmer
        self.poloha = poloha
        self.barva = barva


# reprezentuje objekty v byte
class RamecObjektu:
    def __init__(self, nazev, is_a, typ, znacka, umisteni):
        self.nazev = nazev
        self.is_a = is_a
        self.typ = typ
        self.znacka = znacka
        self.umisteni = umisteni


bytovy_ramec = BytovyRamec("panelak", "Olomouc, Dlouhá 45, 77900",
                           4, "Novák Jan", 110, "4+1",
                           [mistnosti[INDEX_KUCHYNE], mistnosti[INDEX_JIDELNA], mistnosti[INDEX_OBYVAK],
                            mistnosti[INDEX_LOZNICE], mistnosti[INDEX_POKOJ], mistnosti[INDEX_PREDSIN],
                            mistnosti[INDEX_KOUPELNA], mistnosti[INDEX_WC]])
ramce_mistnosti = [
    RamecMistnosti(mistnosti[INDEX_KUCHYNE], "byt", 10, "2x5", "plovouci", [okna[INDEX_OKNO_1]],
                   [dvere[INDEX_DVERE_1], dvere[INDEX_DVERE_2]],
                   [objekty_v_mistnosti[INDEX_STUL]],
                   objekty_v_mistnosti[INDEX_RADIO]),
    RamecMistnosti(mistnosti[INDEX_JIDELNA], "byt", 30, "5x6", "plovouci", [okna[INDEX_OKNO_2]],
                   [dvere[INDEX_DVERE_2], dvere[INDEX_DVERE_3]],
                   [objekty_v_mistnosti[INDEX_STUL], objekty_v_mistnosti[INDEX_ZIDLE]],
                   []),
    RamecMistnosti(mistnosti[INDEX_OBYVAK], "byt", 20, "4x5", "koberec", [okna[INDEX_OKNO_3]],
                   [dvere[INDEX_DVERE_4], dvere[INDEX_DVERE_5]],
                   [objekty_v_mistnosti[INDEX_VAZA], objekty_v_mistnosti[INDEX_KOBEREC]],
                   [objekty_v_mistnosti[INDEX_TELEVIZE]]),
    RamecMistnosti(mistnosti[INDEX_LOZNICE], "byt", 15, "3x5", "koberec", [okna[INDEX_OKNO_5]],
                   [dvere[INDEX_DVERE_6]],
                   [objekty_v_mistnosti[INDEX_SKRIN], objekty_v_mistnosti[INDEX_POSTEL],
                    objekty_v_mistnosti[INDEX_NOCNI_STOLEK], objekty_v_mistnosti[INDEX_LUSTR],
                    objekty_v_mistnosti[INDEX_KOBEREC]],
                   []),
    RamecMistnosti(mistnosti[INDEX_POKOJ], "byt", 20, "4x5", "koberec", [okna[INDEX_OKNO_4]],
                   [dvere[INDEX_DVERE_5]],
                   [objekty_v_mistnosti[INDEX_POSTEL], objekty_v_mistnosti[INDEX_LAMPA],
                    objekty_v_mistnosti[INDEX_KOBEREC]],
                   [objekty_v_mistnosti[INDEX_RADIO], objekty_v_mistnosti[INDEX_TELEVIZE]]),
    RamecMistnosti(mistnosti[INDEX_PREDSIN], "byt", 7, "2x3,5", "plovouci", [],
                   [dvere[INDEX_DVERE_1], dvere[INDEX_DVERE_3], dvere[INDEX_DVERE_4],
                    dvere[INDEX_DVERE_6], dvere[INDEX_DVERE_7]],
                   [],
                   []),
    RamecMistnosti(mistnosti[INDEX_KOUPELNA], "byt", 6, "2x3", "dlazdice", [okna[INDEX_OKNO_6]],
                   [dvere[INDEX_DVERE_7], dvere[INDEX_DVERE_8]],
                   [objekty_v_mistnosti[INDEX_UMYVADLO]],
                   []),
    RamecMistnosti(mistnosti[INDEX_WC], "byt", 2, "2x1", "dlazdice", [],
                   [dvere[INDEX_DVERE_8]],
                   [objekty_v_mistnosti[INDEX_ZACHODOVA_MISA]],
                   [])
]

ramce_oken = [
    OkenniRamec(okna[INDEX_OKNO_1], [mistnosti[INDEX_KUCHYNE]],
                "plastove", "0,7x1,5", [umisteni[UMISTENI_NAPROTI_DVERIM], umisteni[UMISTENI_U_SEVERNI_STENY]], "bila"),
    OkenniRamec(okna[INDEX_OKNO_2], [mistnosti[INDEX_JIDELNA]],
                "plastove", "0,9x1,8", [umisteni[UMISTENI_U_SEVERNI_STENY], umisteni[UMISTENI_NAPROTI_DVERIM]], "bila"),
    OkenniRamec(okna[INDEX_OKNO_3], [mistnosti[INDEX_OBYVAK]],
                "drevene", "0,7x1,5", [umisteni[UMISTENI_U_ZAPADNI_STENY], umisteni[UMISTENI_NAPROTI_DVERIM]], "bila"),
    OkenniRamec(okna[INDEX_OKNO_4], [mistnosti[INDEX_POKOJ]],
                "drevene", "1x2", [umisteni[UMISTENI_U_ZAPADNI_STENY]], "mahagonova"),
    OkenniRamec(okna[INDEX_OKNO_5], [mistnosti[INDEX_LOZNICE]],
                "drevene", "1x2", [umisteni[UMISTENI_NAPROTI_DVERIM], umisteni[UMISTENI_U_JIZNI_STENY]], "mahagonova"),
    OkenniRamec(okna[INDEX_OKNO_6], [mistnosti[INDEX_KOUPELNA]],
                "plastove", "0,9x1,8", [umisteni[UMISTENI_U_JIZNI_STENY], umisteni[UMISTENI_NAPROTI_DVERIM]], "bila")
]

ramce_dveri = [
    DverniRamec(dvere[INDEX_DVERE_1], [mistnosti[INDEX_PREDSIN], mistnosti[INDEX_KUCHYNE]],
                "klasicke", "1x2", [umisteni[UMISTENI_U_SEVERNI_STENY]], "bila"),
    DverniRamec(dvere[INDEX_DVERE_2], [mistnosti[INDEX_KUCHYNE], mistnosti[INDEX_JIDELNA]],
                "s kouli", "1,2x1,9", [umisteni[UMISTENI_U_ZAPADNI_STENY]], "hneda"),
    DverniRamec(dvere[INDEX_DVERE_3], [mistnosti[INDEX_PREDSIN], mistnosti[INDEX_JIDELNA]],
                "klasicke", "1,1x2", [umisteni[UMISTENI_U_SEVERNI_STENY]], "cerna"),
    DverniRamec(dvere[INDEX_DVERE_4], [mistnosti[INDEX_PREDSIN], mistnosti[INDEX_OBYVAK]],
                "klasicke", "0,9x2", [umisteni[UMISTENI_U_ZAPADNI_STENY]], "bila"),
    DverniRamec(dvere[INDEX_DVERE_5], [mistnosti[INDEX_OBYVAK], mistnosti[INDEX_POKOJ]],
                "klasicke", "1x2", [umisteni[UMISTENI_U_JIZNI_STENY]], "bila"),
    DverniRamec(dvere[INDEX_DVERE_6], [mistnosti[INDEX_PREDSIN], mistnosti[INDEX_LOZNICE]],
                "klasicke", "0,95x1,95", [umisteni[UMISTENI_U_JIZNI_STENY]], "hneda"),
    DverniRamec(dvere[INDEX_DVERE_7], [mistnosti[INDEX_PREDSIN], mistnosti[INDEX_KOUPELNA]],
                "s kouli", "1x2", [umisteni[UMISTENI_U_JIZNI_STENY]], "cerna"),
    DverniRamec(dvere[INDEX_DVERE_8], [mistnosti[INDEX_KOUPELNA], mistnosti[INDEX_WC]],
                "klasicke", "1,1x1,9", [umisteni[UMISTENI_U_VYCHODNI_STENY]], "bila")
]

ramce_objektu_v_mistnosti = [
    RamecObjektu(objekty_v_mistnosti[INDEX_SKRIN], [mistnosti[INDEX_LOZNICE]], "klasicka skrin", "IKEA",
                 [umisteni[UMISTENI_U_SEVERNI_STENY], umisteni[UMISTENI_U_DVERI]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_POSTEL], [mistnosti[INDEX_LOZNICE], mistnosti[INDEX_POKOJ]],
                 "dvouluzkova postel", "IKEA", [umisteni[UMISTENI_U_VYCHODNI_STENY]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_NOCNI_STOLEK], [mistnosti[INDEX_LOZNICE]], "nocni stolek", "IKEA",
                 [umisteni[UMISTENI_U_SEVERNI_STENY], umisteni[UMISTENI_NAPROTI_OKNU]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_VAZA], [mistnosti[INDEX_OBYVAK]], "vaza na kvetinu", "ASKO",
                 [umisteni[UMISTENI_U_ZAPADNI_STENY], umisteni[UMISTENI_NAPROTI_OKNU]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_LUSTR], [mistnosti[INDEX_LOZNICE]], "kristalovy lustr", "ASKO",
                 [umisteni[UMISTENI_U_SEVERNI_STENY], umisteni[UMISTENI_U_DVERI], umisteni[UMISTENI_NAPROTI_OKNU]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_KOBEREC], [mistnosti[INDEX_OBYVAK], mistnosti[INDEX_LOZNICE],
                                                      mistnosti[INDEX_POKOJ]],
                 "kratky koberec", "Koberce a. s.", [umisteni[UMISTENI_U_JIZNI_STENY], umisteni[UMISTENI_NAPROTI_DVERIM]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_STUL], [mistnosti[INDEX_KUCHYNE], mistnosti[INDEX_JIDELNA]],
                 "stul", "Stoly a. s.", [umisteni[UMISTENI_U_VYCHODNI_STENY], umisteni[UMISTENI_POD_OKNEM]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_ZIDLE], [mistnosti[INDEX_JIDELNA]], "klasicka zidle",
                 "IKEA", [umisteni[UMISTENI_U_SEVERNI_STENY], umisteni[UMISTENI_U_DVERI]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_TELEVIZE], [mistnosti[INDEX_OBYVAK], mistnosti[INDEX_POKOJ]], "LED televizor",
                 "HP", [umisteni[UMISTENI_U_VYCHODNI_STENY]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_LAMPA], [mistnosti[INDEX_POKOJ]], "lampa", "Lampy s. r. o.",
                 [umisteni[UMISTENI_U_JIZNI_STENY], umisteni[UMISTENI_NAPROTI_DVERIM]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_RADIO], [mistnosti[INDEX_KUCHYNE], mistnosti[INDEX_POKOJ]], "radio",
                 "Sencor", [umisteni[UMISTENI_U_VYCHODNI_STENY]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_UMYVADLO], [mistnosti[INDEX_KOUPELNA]], "umyvadlo", "Umyvadla s. r. o.",
                 [umisteni[UMISTENI_U_VYCHODNI_STENY], umisteni[UMISTENI_POD_OKNEM]]),
    RamecObjektu(objekty_v_mistnosti[INDEX_ZACHODOVA_MISA], [mistnosti[INDEX_WC]], "zachodova misa", "IKEA",
                 [umisteni[UMISTENI_U_SEVERNI_STENY], umisteni[UMISTENI_NAPROTI_DVERIM]])
]


# vrati pole vsech ramcu
def ziskej_vsechny_ramce():
    return [bytovy_ramec, ramce_mistnosti, ramce_oken, ramce_dveri, ramce_objektu_v_mistnosti]
