# Autor: Lukas Sobotka
# Datum: 6. 11. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi pro rizeni celeho projektu, pouziva funkci komunikacniho modulu pro komunikaci s uzivatelem
# ------------------------------------------------------------------------------------------------
import Komunikacni_modul
from baze_dat import mistnosti, hlavni_dvere
from baze_znalosti import Byt, Nabytek


# Funkce prida uzivatelsky zadany kus nabytku do baze dat
def pridani_nabytku():
    mistnost = Komunikacni_modul.ziskej_mistnost()
    nabytek = Komunikacni_modul.ziskej_nabytek()
    new_nabytek = Nabytek(nabytek[0], nabytek[1], nabytek[2], nabytek[3], nabytek[4])
    mistnost.nabytek.append(new_nabytek)


# Funkce se stara o prochazeni bytem po jednotlivych mistnostech jednotlivymi dvermi
def prochazeni_bytem():
    mistnost = hlavni_dvere.vede_do
    while True:
        Komunikacni_modul.vypis_nabytek(mistnost)
        dvere = Komunikacni_modul.zvol_dvere(mistnost)
        if dvere == hlavni_dvere:
            break
        if dvere.vede_do == mistnost:
            mistnost = dvere.vede_z
        else:
            mistnost = dvere.vede_do


# Hlavni funkce programu
def start():
    byt = Byt("Strachovska 87", "Petr Pankrac", "Elsika Krasna", mistnosti)
    Komunikacni_modul.vypis_intro(byt)

    while True:
        match Komunikacni_modul.ptej_se():
            case 'a':
                Komunikacni_modul.vypis_mistnosti()

            case 'b':
                mistnost = Komunikacni_modul.ziskej_mistnost()
                Komunikacni_modul.vypis_nabytek(mistnost)

            case 'c':
                pridani_nabytku()

            case 'd':
                prochazeni_bytem()

            case 'e':
                break

            case _:
                print("Spatny vstup")

    input('stisknete ENTER pro ukonceni')
