# Autor: Lukas Sobotka
# Datum: 13. 11. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi pro komunikaci s uzivatelem
# ------------------------------------------------------------------------------------------------
from baze_dat import mistnosti, umisteni, hlavni_dvere


# Vypise uvodni zpravu
def vypis_intro(byt):
    print("Vitejte, prave jste spustili znalostni system, ktery popisuje rozvrzeni bytu " + byt.adresa)
    print("Vyberte z nabidky to co vas nejvice zajima a nezapomente stisknout ENTER pro potvrzeni")


# Pta se uzivatele a odpoved vraci zpet inferencnimu modului
def ptej_se():
    print("------------------------------------------------------------------------------------------------")
    print("Vyberte jednu z moznosti?")
    print("a) Vypsat vsechny mistnosti v byte.")
    print("b) Vypsat vsechen nabytek umisteny v urcite mistnosti.")
    print("c) Pridat vami zadany kus nabytku do mistnosti v byte.")
    print("d) Vejit do bytu hlavnim vchodem a prochazet byt po mistnostech")
    print("e) Konec.")
    return input(">")


# Vypise nazvy vsech mistnosti z baze dat
def vypis_mistnosti():
    vystup = "[ "
    for mistnost in mistnosti:
        vystup += str(mistnost) + " "
    print(vystup + "]")


# Pta se uzivatele na zvoleni mistnosti a zvolenou mistnost vraci
def ziskej_mistnost():
    while True:
        vypis_mistnosti()
        print("Zvolte jednu z uvedenych mistnosti")
        vstup = input(">")
        for mistnost in mistnosti:
            if str(mistnost) == vstup:
                return mistnost
        print('Spatny vstup')


# Vypise vsechen nabytek a okna v zadane mistnosti
def vypis_nabytek(mistnost):
    vystup = ""
    for misto in umisteni:

        for okno in mistnost.okna:
            if okno.smeruje_na == misto:
                vystup += str(okno) + "\n"

        for nabytek in mistnost.nabytek:
            if nabytek.umisteni == misto:
                vystup += str(nabytek) + "\n"

        if vystup != "":
            print("Kdyz se zamerime na " + misto + " mistnosti vidime:\n" + vystup)
            vystup = ""


# Pta se uzivatele na dotazy pro vytvoreni noveho nabytku, odpovedi uzivatele vraci jako seznamu infercnimu modulu
def ziskej_nabytek():
    nabytek = [input("Zadej nazev noveho kusu nabytku"),
               input("Zadej zhruba velikost noveho kusu nabytku"),
               input("Zadej jmeno vyrobce nabytku"),
               input("Zadej zhruba vahu noveho kusu nabytku")]
    while True:
        vstup = input("Zvol kde v mistnosti bude nabytek umisten (sever, jih, zapad, vychod, prostredek)")
        if umisteni.__contains__(vstup):
            nabytek.append(vstup)
            return nabytek


# Vypise uzivateli dvere v mistnosti a umozni mu zvolit si do kterych chce vejit
# tyto zvolene dvere vraci v navratove hodnote inferncnimu modulu
def zvol_dvere(mistnost):
    # vypsani dveri
    i = 1
    for dvere in mistnost.dvere:
        if (dvere.vede_z == 'Venek') | (dvere.vede_do == 'Venek'):
            print("Dvere " + str(i) + " jsou hlavni dvere vedouci ven")
        else:
            if dvere.vede_z == mistnost:
                print("Dvere " + str(i) + " vedou do mistnosti " + str(dvere.vede_do) + ".")
            else:
                print("Dvere " + str(i) + " vedou do mistnosti " + str(dvere.vede_z) + ".")
        i += 1

    # zvoleni jednech vypsanych dveri podle cisla
    while True:
        print("Zvolte cislo dveri do kterych chcete vejit (Pro navraceni do puvodni nabidky napiste exit)")
        vstup = input(">")
        if vstup == 'exit':
            return hlavni_dvere
        if vstup.isdigit():
            if int(vstup) > 0:
                if int(vstup) < i:
                    return mistnost.dvere[int(vstup) - 1]
