# ------------------------------------------------------------------------------------------------
# Autor: Lukas Sobotka
# Datum: 13. 11. 2023
# Verze 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k ukladani jednotlivych dat
# ------------------------------------------------------------------------------
from baze_znalosti import Mistnost, Okno, Nabytek, Dvere

# nabytek muze byt v mistnosti umisten na jednu z techto peti pozic
umisteni = ["vychod", "zapad", "jih", "sever", "prostredek"]

# jakych typu mohou byt mistnosti
typy_mistnosti = ['koupelna', 'kuchyn', 'obyvaci_pokoj', 'loznice', 'chodba', 'pracovna', 'zachod', 'predsin']

# nadefinujeme mistnosti
predsin = Mistnost('predsin', 8, [], [], [])
chodba = Mistnost('chodba', 8, [], [], [])
zachod = Mistnost('zachod', 3, [], [], [])
koupelna = Mistnost('koupelna', 12, [], [], [])
kuchyn = Mistnost('kuchyn', 15, [], [], [])
loznice = Mistnost('loznice', 14, [], [], [])
obyvak = Mistnost('obyvaci_pokoj', 15, [], [], [])
pracovna = Mistnost('pracovna', 11, [], [], [])

# pro kazdou mistnost nsdefinujeme i jeji okna a nabytek
# predsin
predsin.okna = [Okno('plastove', 60, 80, "vychod"),
                Okno('plastove', 40, 20, "sever")]
predsin.nabytek = [Nabytek('Botnik', '30x60x30', 'Woodworks', 15, "vychod"),
                   Nabytek('Vesak', '180x10x10', 'Woodworks', 4, "sever"),
                   Nabytek('Kulaty koberecek', '30x30', 'Knitten', 5, 'prostredek'),
                   Nabytek('Zidle', '25x25x45', 'Mauricio', 5, "sever")

                   ]
# chodba
chodba.nabytek = [Nabytek('Koberec', '300x90', 'Knitten', 12, 'prostredek')]

# zachod
zachod.nabytek = [Nabytek('Zachod', '25x40x80', 'Ravak', 25, "jih"),
                  Nabytek('Male umyvadlo', '20x10', 'Ravak', 10, "zapad")]
zachod.okna = [Okno('drevene', 40, 20, "vychod")]

# koupelna
koupelna.nabytek = [Nabytek('Zrdcadlo', '70x35', 'Glaswerk', 10, "zapad"),
                    Nabytek('Umyvadlo', '30x30', 'Ravak', 25, "vychod"),
                    Nabytek('Sprchovy kout', '60x60x200', 'Ravak', 20, "zapad"),
                    Nabytek('Gumovy koberecek', '110x60', 'Terra', 1, 'prostredek')]
koupelna.okna = [Okno('drevene', 40, 20, "vychod")]

# kuchyn
kuchyn.nabytek = [Nabytek('Linka', '50x230x50', 'Mobelix', 170, "sever"),
                  Nabytek('Drez', '50x60x50', 'Mobelix', 30, "sever"),
                  Nabytek('Kredenc', '50x60x60', 'IKEA', 35, "zapad"),
                  Nabytek('Sporak', '50x50x60', 'Bosch', 60, "zapad"),
                  Nabytek('Stul', '100x100x60', 'IKEA', 18, "vychod"),
                  Nabytek('3 zidle', '30x30x60', 'IKEA', 5, "vychod"),
                  Nabytek('Mikrovlnka', '20x30x30', 'Electrolux', 20, "sever"),
                  Nabytek('Lednice', '180x50x50', 'Gorenje', 40, "sever")]

kuchyn.okna = [Okno('plastove', 60, 80, "sever"),
               Okno('plastove', 60, 80, "sever")]
 # loznice
loznice.nabytek = [Nabytek('Postel', '210x230x30', 'IKEA', 70, "sever"),
                   Nabytek('2 nocni stolky', '30x30x30', 'IKEA', 15, "sever"),
                   Nabytek('Skrin', '210x50x70', 'Woodworks', 35, "zapad"),
                   Nabytek('Skrin', '210x50x70', 'IKEA', 33, "jih"),
                   Nabytek('Makeup stolek', '180x60x50', 'Aga', 38, "jih")]
loznice.okna = [Okno('plastove', 60, 80, "zapad")]

# obyvaci pokoj
obyvak.nabytek = [Nabytek('Chlupaty koberec', '400x350', 'BRENO', 13, 'prostredek'),
                  Nabytek('Gauc', '100x40x30', 'IKEA', 32, "vychod"),
                  Nabytek('Kreslo', '60x50x40', 'Aga', 30, "sever"),
                  Nabytek('Skrinka s televizi', '60x60x20', 'IKEA', 25, "zapad")]
obyvak.okna = [Okno('plastove', 60, 80, "jih")]

# pracovna
pracovna.nabytek = [Nabytek('Skrin', '210x50x70', 'IKEA', 33, "jih"),
                    Nabytek('Pracovni stul', '90x50x60', 'Woodworks', 30, "zapad"),
                    Nabytek('Knihovna', '180x30x70', 'IKEA', 25, "sever"),
                    Nabytek('Koberec', '350x250', 'BRENO', 13, 'prostredek'),
                    Nabytek('Zidle', '30x30x60', 'IKEA', 5, "zapad"),
                    Nabytek('Skrinka', '50x60x50', 'IKEA', 20, "jih")]
pracovna.okna = [Okno('plastove', 60, 80, "jih"),
                 Okno('plastove', 60, 80, "zapad")]

# nadefinujeme dvere
hlavni_dvere = Dvere(200, 80, 'Venek', predsin)
dvere_pred_chod = Dvere(200, 80, predsin, chodba)
dvere_chod_zach = Dvere(200, 80, chodba, zachod)
dvere_chod_koup = Dvere(200, 80, chodba, koupelna)
dvere_chod_kuch = Dvere(200, 80, chodba, kuchyn)
dvere_chod_loz = Dvere(200, 80, chodba, loznice)
dvere_chod_obyv = Dvere(200, 80, chodba, obyvak)
dvere_obyv_prac = Dvere(200, 80, obyvak, pracovna)

# pridame nadefinovane dvere k jejim mistnostem
obyvak.dvere = [dvere_chod_obyv, dvere_obyv_prac]
pracovna.dvere = [dvere_obyv_prac]
predsin.dvere = [hlavni_dvere, dvere_pred_chod]
chodba.dvere = [dvere_chod_obyv, dvere_chod_kuch, dvere_chod_koup, dvere_chod_loz, dvere_chod_zach, dvere_pred_chod]
zachod.dvere = [dvere_chod_zach]
koupelna.dvere = [dvere_chod_koup]
kuchyn.dvere = [dvere_chod_kuch]
loznice.dvere = [dvere_chod_loz]

# seznam vsech mistnosti
mistnosti = [chodba, predsin, zachod, koupelna, kuchyn, loznice, obyvak, pracovna]
