# Autor: Lukas Sobotka
# Datum: 6. 11. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k ukladani jednotlivych znalosti o datech
# ------------------------------------------------------------------------------------------------

# tato trida predstavuje ramcovou reprezentaci bytu
class Byt:
    # adresa - fyzicka adresa bytu
    # majitel - vlastnik bytu
    # najemnik - aktualni najemnik co zije v byte
    # mistnosti - seznam vsech mistnosti v byte
    def __init__(self, adresa, majitel, najemnik, mistnosti):
        self.adresa = adresa
        self.majitel = majitel
        self.najemnik = najemnik
        self.mistnosti = mistnosti


# tato trida predstavuje ramcovou reprezentaci mistnosti
class Mistnost:
    # nazev - nazev mistnosti
    # rozloha - rozloha v metrech ctverecnich
    # nabytek - seznam veskereho nabytku v mistnosti
    # okna - seznam vsech oken v mistnosti
    # dvere - seznam vsech devri v mistnosti
    def __init__(self, nazev, rozloha, nabytek, okna, dvere):
        self.nazev = nazev
        self.rozloha = rozloha
        self.nabytek = nabytek
        self.okna = okna
        self.dvere = dvere

    def __str__(self):
        return self.nazev


# tato trida predstavuje ramcovou reprezentaci nabytku
class Nabytek:
    # typ_nabytku - o jaky typ nabytku se jedna
    # velikost - rozmery v cm
    # vyrobce - vyrobce nabytku
    # vaha - jak je nabytek tezky v kg
    # umisteni - kde v mistnosti je nabytek unmisten
    def __init__(self, typ_nabytku, velikost, vyrobce, vaha, umisteni):
        self.typ_nabytku = typ_nabytku
        self.velikost = velikost
        self.vyrobce = vyrobce
        self.vaha = vaha
        self.umisteni = umisteni

    def __str__(self):
        return str(self.typ_nabytku) + " o velikosti " + str(self.velikost) + " a vaze " + str(self.vaha) + " kg s vyrobcem " + str(self.vyrobce)


# tato trida predstavuje ramcovou reprezentaci dveri
class Dvere:
    # vyska, sirka - vyska a sirka dveri
    # vede_z - z jake mistnosti dvere vedou
    # vede_do - do jake mistnosti dvere vedou
    def __init__(self, vyska, sirka, vede_z, vede_do):
        self.vyska = vyska
        self.sirka = sirka
        self.vede_z = vede_z
        self.vede_do = vede_do

    def __str__(self):
        return "Dvere o velikosti " + str(self.vyska) + "x" + str(self.sirka) + " vedouci do "


# tato trida predstavuje ramcovou reprezentaci oken
class Okno:
    # typ - typ okna (drevene, plastove)
    # vyska, sirka - vyska a sirka okna
    # smeruje - na jakou svetovou stranu okno smeruje
    def __init__(self, typ, vyska, sirka, smeruje_na):
        self.typ = typ
        self.vyska = vyska
        self.sirka = sirka
        self.smeruje_na = smeruje_na

    def __str__(self):
        return str(self.typ) + " okno o velikosti " + str(self.vyska) + "x" + str(self.sirka) + " smerujici na " + str(self.smeruje_na)
