"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: November 06, 2023
Version: 1.0.0
Description: Inference engine of expert system, getting user choices
"""

import KomunikacniModul
import VysvetlovaciModul


def app():
    """
    Start and end of the application
    """
    print(KomunikacniModul.welcome_text)
    point_of_choices()
    print(KomunikacniModul.farewell)


def point_of_choices():
    """
    Method prints choices to the user and collecting user input
    """
    user_choice = 1
    while user_choice != 6:
        print(KomunikacniModul.question)
        print(KomunikacniModul.basic_choices)
        print(KomunikacniModul.separator)
        print(KomunikacniModul.enter_input, end="")
        user_input = input()
        user_choice = switch_method(user_input)
        if user_choice != 6 and user_choice != -1:
            print(KomunikacniModul.instructions_to_continue)
            input()
        print(KomunikacniModul.separator)


def switch_method(command):
    """
    Method to process user input and determine the user choice
    :param command: the user input.
    :return: The user's choice (1-6) or -1 for an invalid choice.
    """
    parsed = command.split()
    if len(parsed) > 0:
        if parsed[0] == '1':
            return list_of_items_choice()
        elif parsed[0] == '2':
            return VysvetlovaciModul.where_is(command)
        elif parsed[0] == '3':
            return VysvetlovaciModul.doors_connect(command)
        elif parsed[0] == '4':
            return VysvetlovaciModul.print_information(command)
        elif parsed[0] == '5':
            return VysvetlovaciModul.print_help(command)
        elif parsed[0] == '6':
            return VysvetlovaciModul.exit(command)
        else:
            print(KomunikacniModul.invalid_input)
            return -1
    else:
        -1

def list_of_items_choice():
    """
    Method asks the user which type of objects user want to see
    """
    print(KomunikacniModul.choice_print_list_of_items)
    print(KomunikacniModul.enter_input, end="")
    user_choice = input()
    if user_choice == '1':
        VysvetlovaciModul.print_all()
    elif user_choice == '2':
        VysvetlovaciModul.print_flats()
    elif user_choice == '3':
        VysvetlovaciModul.print_rooms()
    elif user_choice == '4':
        VysvetlovaciModul.print_windows()
    elif user_choice == '5':
        VysvetlovaciModul.print_doors()
    elif user_choice == '6':
        VysvetlovaciModul.print_furniture()
    elif user_choice == '7':
        VysvetlovaciModul.print_electric_devices()
    else:
        print(KomunikacniModul.wrong_choice)
