# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 28. 10. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k zjisteni pozice objektu v byte, respektive k nalezeni vsech objektu
# v urcite mistnosti, nebo k zjisteni, kam vedou jake dvere.
# ------------------------------------------------------------------------------------------------


# Spusti program.
def spust_program():
    from komunikacni_modul import ptej_se
    ptej_se()


# Ziska vsechna obsazena umisteni v mistnosti
# (tzn. jen ta, na kterych je alespon jeden objekt).
def vsechna_umisteni_v_mistnosti(mistnost):
    from komunikacni_modul import ziskej_ramce_objektu_v_mistnosti
    vsechny_objekty = ziskej_ramce_objektu_v_mistnosti()
    nalezene_umisteni = {}
    for objekt in vsechny_objekty:
        ve_spravne_mistnosti = False
        # zajimaji nas pouze objekty v urcene mistnosti
        for m in objekt.is_a:
            if m == mistnost.jmeno:
                ve_spravne_mistnosti = True
        if not ve_spravne_mistnosti:
            continue
        # projdeme vsechna umisteni objektu (vetsinou je jich vice ktere se nevylucuji,
        # jako napr. u severni steny a proti dverim) a hledame dosud nenalezene umisteni
        for umisteni in objekt.umisteni:
            nalezene_umisteni[umisteni] = True
    return list(nalezene_umisteni.keys())


# Ziska vsechny predmety v mistnosti.
def predmety_v_mistnosti(mistnost):
    from komunikacni_modul import ziskej_ramce_objektu_v_mistnosti
    k_vraceni = []
    vsechny_objekty = ziskej_ramce_objektu_v_mistnosti()
    for objekt in vsechny_objekty:
        ve_spravne_mistnosti = False
        for m in objekt.is_a:
            if m == mistnost.jmeno:
                ve_spravne_mistnosti = True
        if ve_spravne_mistnosti:
            k_vraceni.append(objekt)
    return k_vraceni


# Ziska vsechny predmety z urcite mistnosti na urcitem miste.
def predmety_s_umistenim(mistnost, umisteni):
    k_vraceni = []
    for objekt in predmety_v_mistnosti(mistnost):
        # zajima nas pouze objekt se spravnym umistenim
        nalezeno = False
        for u in objekt.umisteni:
            if u == umisteni:
                nalezeno = True
        if nalezeno:
            k_vraceni.append(objekt)
    return k_vraceni


# Zjisti, kam vedou dvere z dane mistnosti.
def kam_vedou_dvere(mistnost):
    from komunikacni_modul import ziskej_ramce_dveri
    k_vraceni = []
    dvere = ziskej_ramce_dveri()
    for d in dvere:
        if d.is_a[0] == mistnost.jmeno:
            k_vraceni.append(d.is_a[1])
        elif d.is_a[1] == mistnost.jmeno:
            k_vraceni.append(d.is_a[0])
    return k_vraceni
