"""
@author Vitaliy Bohera
@version 1
@info Inferenci modul znalostniho systemu pro reprezentaci rozložení a vybavení bytu
@date 10.11.2023
"""
import komunikace
import vysvetlovaci_modul
import data


# Spusteni celeho systemu
def start_system():
    komunikace.uvod_do_systemu()
    komunikace.vypis_seznam_zprav()

    # nekonecna smycka kde cekame na zpravy od uzivatele, na ktere pak reagujeme
    pokracuj = True
    while pokracuj:
        zprava = komunikace.zeptej_se_na_vstup()

        if zprava == "q" or zprava == "Q":
            pokracuj = False
        elif zprava == "help":
            print("\n")
            komunikace.vypis_seznam_zprav()
        elif zprava == "1":
            vysvetlovaci_modul.vypis_info_byt()
        elif zprava == "2":
            vysvetlovaci_modul.vypis_mistnosti_v_byte()
        elif len(zprava.split()) == 2:
            casti_zpravy = zprava.split()
            kontrola = kontrola_vstupu(casti_zpravy[1])
            if kontrola == 1:
                komunikace.spatny_vstup()
            else:
                if casti_zpravy[0] == "3":
                    vysvetlovaci_modul.vypis_info_mistnost(casti_zpravy[1])
                elif casti_zpravy[0] == "4":
                    vysvetlovaci_modul.vypis_nabytek_v_mistnosti(casti_zpravy[1])
                elif casti_zpravy[0] == "5":
                    vysvetlovaci_modul.vypis_pocet_oken(casti_zpravy[1])
                elif casti_zpravy[0] == "6":
                    vysvetlovaci_modul.vypis_kam_se_dostanu(casti_zpravy[1])
                elif casti_zpravy[0] == "7":
                    vysvetlovaci_modul.vypis_info_okna(casti_zpravy[1])
                elif casti_zpravy[0] == "8":
                    vysvetlovaci_modul.vypis_info_dvere(casti_zpravy[1])
        else:
            komunikace.spatny_vstup()
    komunikace.konec()


'''
Funkce pro kontrolu vstupu, zda existuje takova mistnost v byte
@param mistnost - retezec ktery kontrolujem 
'''
def kontrola_vstupu(mistnost):
    result = 1
    for key, value in data.byt["místnosti"].items():
        if key == mistnost:
            result = 0
    return result
