# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 11. 11. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Modul slouzi ke vzajemne komunikaci ostatnich modulu mezi sebou.
# ------------------------------------------------------------------------------------------------
import baze_dat
import inferencni_modul
import vysvetlovaci_modul


# Vrati vsechny definovane mistnosti.
def ziskej_mistnosti():
    return baze_dat.mistnosti


# Vrati vsechna okna.
def ziskej_okna():
    return baze_dat.okna


# Vrati vsechny dvere.
def ziskej_dvere():
    return baze_dat.dvere


# Vrati vsechny objekty v mistnosti.
def ziskej_objekty_v_mistnosti():
    return baze_dat.objekty_v_mistnosti


# Vrati vsechna dostupna umisteni pro objekt.
def ziskej_umisteni():
    return baze_dat.umisteni


# Vrati instanci bytoveho ramce.
def ziskej_bytovy_ramec():
    from baze_znalosti import ziskej_vsechny_ramce
    return ziskej_vsechny_ramce()[0]


# Vrati vsechny instance ramcu mistnosti.
def ziskej_ramce_mistnosti():
    from baze_znalosti import ziskej_vsechny_ramce
    return ziskej_vsechny_ramce()[1]


# Vrati vsechny ramce oken.
def ziskej_ramce_oken():
    from baze_znalosti import ziskej_vsechny_ramce
    return ziskej_vsechny_ramce()[2]


# Vrati vsechny ramce dveri.
def ziskej_ramce_dveri():
    from baze_znalosti import ziskej_vsechny_ramce
    return ziskej_vsechny_ramce()[3]


# Vrati vsechny ramce objektu.
def ziskej_ramce_objektu_v_mistnosti():
    from baze_znalosti import ziskej_vsechny_ramce
    return ziskej_vsechny_ramce()[4]


# Vrati vsechna umisteni pro urcitou mistnost,
# na kterych se nachazi alespon jeden prvek.
def ziskej_umisteni_pro_mistnost(mistnost):
    return inferencni_modul.vsechna_umisteni_v_mistnosti(mistnost)


# Vrati vsechny predmety, ktere se nachazi v urcite mistnosti
# na urcitem umisteni.
def zikej_predmety_s_umistenim(mistnost, umisteni):
    return inferencni_modul.predmety_s_umistenim(mistnost, umisteni)


# Vrati vsechny predmety z urcite mistnosti.
def ziskej_predmety_v_mistnosti(mistnost):
    return inferencni_modul.predmety_v_mistnosti(mistnost)


# Zjisti, kam vedou dvere z urcite mistnosti
# (z 1 mistnosti muze vest vice dveri).
def zjisti_kam_vedou_dvere(mistnost):
    return inferencni_modul.kam_vedou_dvere(mistnost)

def ptej_se():
    vysvetlovaci_modul.ziskej_data_od_uzivatele()
