"""
Description: Tento modul komunikuje s uživatelem.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 13.11.2023
"""
import vysvetlovaci_modul


def start_info():
    # vypise uvod
    print("Vítáme Vás ve znalostním systému pro reprezentaci rozložení a vybavení bytu.\n"
          "Níže máte na výběr z několika možností, které vám blíže přiblíží rozložení bytu.\n"
          "Ovládání: Výběr možností je realizován zadáním čísla možnosti.\n"
          "Zadání musí být vždy potvrzeno klávesou ENTER")


def options():
    # vypisuje uzivateli moznosti dokud neukonci program
    divider()
    print("Možnosti:")
    print("1. Výpis všech místností v bytě.")
    print("2. Výpis detailů o místnosti.")
    print("3. Výpis objektů v místnosti.")
    print("4. Výpis dostupných místností z určité místnosti.")
    print("5. Výpis detailů o bytě.")
    print("6. Ukoncit program.")
    selection = int(input("Volba: "))
    match selection:
        case 1:
            vysvetlovaci_modul.print_rooms()
        case 2:
            room_index = vysvetlovaci_modul.print_rooms_opt() - 1
            vysvetlovaci_modul.print_room_details(room_index)
        case 3:
            room_index = vysvetlovaci_modul.print_rooms_opt() - 1
            vysvetlovaci_modul.room_contents(room_index)
        case 4:
            room_index = vysvetlovaci_modul.print_rooms_opt() - 1
            vysvetlovaci_modul.print_room_door_destination(room_index)
        case 5:
            vysvetlovaci_modul.print_flat_details()
        case 6:
            exit()
        case _:
            print("Chyba vstupu, zkuste znovu.")


def divider():
    # vypise oddelovac
    print("___________________________________________________________________")