# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 11. 11. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Modul slouzi ke komunikaci s uzivatelem.
# ------------------------------------------------------------------------------------------------
import komunikacni_modul


# Zepta se uzivatele, jakou chce zvolit mistnost a tuto mistnost vrati.
def zeptej_se_na_mistnost():
    mistnosti = komunikacni_modul.ziskej_ramce_mistnosti()
    print("V byte jsou dostupne nasledujici mistnosti. Do ktere se chcete podivat?")
    # ord ziska ASCII hodnotu znaku a chr prevede ASCII hodnotu zpet na znak
    for i in range(len(mistnosti)):
        mistnost = mistnosti[i]
        print("{}) {}".format(chr(ord("a") + i), mistnost.jmeno))
    volba = input("Vase volba: ")
    # volba musi byt v rozsahu <a, a+len(mistnosti)-1>
    index_mistnosti = ord(volba) - ord("a")
    if index_mistnosti < 0 or index_mistnosti >= len(mistnosti):
        print("Neplatna volba. Zkuste to prosim znovu.")
        return zeptej_se_na_mistnost()
    mistnost = mistnosti[index_mistnosti]
    return mistnost


def vypis_predmet(predmet):
    print("{} od vyrobce {}".format(predmet.nazev, predmet.znacka))


# Tato funkce se pta uzivatele na to, co by chtel udelat. Nasledne necha
# inferencni modul najit reseni (pres komunikacni modul) a vypise vysledek.
def ziskej_data_od_uzivatele():
    print("Vitejte ve znalostnim systemu, ktery Vam pomuze zjistit strukturu bytu. ")
    print("Program se Vas zepta na nekolik otazek, na ktere muzete odpovedet vyberem z nabidky ")
    print("(zadani prislusneho pismena). Volbu potvrdte stiskem klavesy ENTER.")
    print("------------------------------------------------------------------------------------------------")
    print("Autor: Dominik Vladar")
    print("Verze: 1.0")
    print("Datum: 11.11.2023")
    print("Predmet: KIV/UZI")
    print("Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved")
    while True:
        print("------------------------------------------------------------------------------------------------")
        print("Co si prejete udelat?")
        print("a) Vypsat vsechny dostupne mistnosti v byte.")
        print("b) Zjistit, co se nachazi na urcitem miste v byte.")
        print("c) Vypsat veskere vybaveni z urcite mistnosti.")
        print("d) Zjistit, kam vedou dvere z nejake mistnosti.")
        print("e) Ukoncit program.")
        volba = input("Vase volba: ")
        match volba:
            case "a":
                print("V byte se nachazi tyto mistnosti:")
                for mistnost in komunikacni_modul.ziskej_ramce_mistnosti():
                    print(mistnost.jmeno)

            case "b":
                mistnost = zeptej_se_na_mistnost()
                vsechna_umisteni = komunikacni_modul.ziskej_umisteni_pro_mistnost(mistnost)
                if len(vsechna_umisteni) == 0:
                    print("V mistnost {} nejsou zadne predmety, takze neni kam se podivat.".format(mistnost.jmeno))
                    continue
                print("V mistnosti {} jsou dostupne nasledujici umisteni. Na jake misto se chcete podivat?"
                      .format(mistnost.jmeno))
                for i in range(len(vsechna_umisteni)):
                    umisteni = vsechna_umisteni[i]
                    print("{}) {}".format(chr(ord("a") + i), umisteni))
                volba = input("Vase volba: ")
                index_umisteni = ord(volba) - ord("a")
                if index_umisteni < 0 or index_umisteni >= len(vsechna_umisteni):
                    print("Neplatna volba. Zadejte prosim svoje volby znovu.")
                    continue
                umisteni = vsechna_umisteni[index_umisteni]
                print("Na umisteni {} naleznete: ".format(umisteni))
                for predmet in komunikacni_modul.zikej_predmety_s_umistenim(mistnost, umisteni):
                    vypis_predmet(predmet)

            case "c":
                mistnost = zeptej_se_na_mistnost()
                predmety = komunikacni_modul.ziskej_predmety_v_mistnosti(mistnost)
                if len(predmety) == 0:
                    print("V mistnosti {} nejsou zadne predmety.".format(mistnost.jmeno))
                    continue
                print("V mistnosti {} naleznety tyto predmety:".format(mistnost.jmeno))
                for predmet in predmety:
                    vypis_predmet(predmet)

            case "d":
                mistnost = zeptej_se_na_mistnost()
                mistnosti = komunikacni_modul.zjisti_kam_vedou_dvere(mistnost)
                print("Dvere v mistnosti {} vedou do techto mistnosti:".format(mistnost.jmeno))
                for m in mistnosti:
                    print(m)

            case "e":
                print("Nashledanou.")
                return

            case _:
                # default case, vstup byl zadan chybne
                print("Spatne zadany vstup. Zkuste to prosim znovu.")
