"""
Description: Tento modul slouží k dodání informací uživateli pokud si o ně zažádá.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 13.11.2023
"""
from baze_znalosti import rooms, object_frames, room_frames, flat_frame, door_frames


def print_rooms():
    # vypise mistnosti v bytu oddelene carkou
    print("Místnosti: ")
    print(', '.join(rooms))
    return


def print_rooms_opt():
    # vypise mistnosti v bytu jako moznosti pro uzivatele
    print("Vyberte místnost: ")
    for i, room in enumerate(rooms):
        print(str(i + 1) + ". " + room)
    selection = int(input("Volba: "))
    if selection < 1 or selection > len(rooms):
        print("Chyba vstupu, zkuste znovu.")
        return print_rooms_opt()
    return selection


def print_room_details(room_index):
    """
    Vypise detaily o pozadovane mistnosti
    :param room_index: index pozadovane mistnosti
    :return:
    """
    room = room_frames[room_index]
    print(room.name + " se nachází v: " + room.is_in + ", má velikost: " + str(room.size) + " m2 a podlahu typu "
          + room.flooring + ".")
    return


def print_flat_details():
    # vypise detaily o bytu
    print("Byt se nachází v: " + flat_frame.is_in + ", na adrese " + flat_frame.address + " v patře "
          + str(flat_frame.floor) + " je typu " + flat_frame.flat_type + ", má velikost " + str(flat_frame.size)
          + " m2 a vlastníkem je " + flat_frame.owner + ".")
    return


def print_room_door_destination(room_index):
    """
    Vypise dostupne mistnosti z urcite mistnosti.
    :param room_index: index mistnosti z ktere zjistujeme dostupnost
    :return:
    """
    destinations = []
    room = room_frames[room_index].name
    for door in door_frames:
        if door.is_in[0] == room:
            destinations.append(door.is_in[1])
        elif door.is_in[1] == room:
            destinations.append(door.is_in[0])
    print("Z místnosti " + room + " vedou dveře do místností: ")
    print(', '.join(destinations))
    return


def room_contents(room_index):
    """
    Vypise objekty v pozadovane mistnosti.
    :param room_index: index pozadovane mistnosti
    :return:
    """
    room_objects = []
    room = room_frames[room_index]
    if len(room.furniture) == 0 and len(room.electrical_appliances) == 0:
        print("V místnosti se nenacházejí žádné objekty.")
        return
    print("V místnosti se nachází následující objekty: ")
    for obj in object_frames:
        for r in obj.is_in:
            if r == room.name:
                room_objects.append(obj)
    for o in room_objects:
        print(o.object_type + " se nachází na místě: " + o.position + ".")
    return
