"""
@author Vitaliy Bohera
@version 1
@info Vysvetlovaci modul znalostniho systemu pro reprezentaci rozložení a vybavení bytu
@date 10.11.2023
"""
import znalosti


'''
Funkce vypise info o byte'''
def vypis_info_byt():
    print("------------------")
    print("Informace o bytě: ")
    print("------------------")
    info = znalosti.info_byt()
    for key, value in info.items():
        print("- " + key + ": " + value)
    print("------------------\n")


'''
Funkce vypise info o dane mistnosti
@param mistnost - mistnost v byte
'''
def vypis_info_mistnost(mistnost):
    print("------------------")
    print("Informace o místnosti - {0}: ".format(mistnost))
    print("------------------")
    info = znalosti.info_mistnost(mistnost)
    for key, value in info.items():
        print("- " + key + ": " + value)
    print("------------------\n")


'''
Funkce vypise seznam vsech mistnosti v byte
'''
def vypis_mistnosti_v_byte():
    print("------------------")
    print("Místnosti v bytě: ")
    print("------------------")
    mistnosti = znalosti.mistnosti_byt()
    for mistnost in mistnosti:
        print("- " + mistnost)
    print("------------------\n")


'''
Funkce vypise nabytek, ktery je v dane mistnosti
@param mistnost - mistnost v byte
'''
def vypis_nabytek_v_mistnosti(mistnost):
    print("---------------------------")
    print("Nábytek v místnosti - {0}: ".format(mistnost))
    print("---------------------------")
    nabytek = znalosti.zjisti_nabytek(mistnost)
    for x in nabytek:
        print("- " + x)
    print("---------------------------\n")


'''
Funkce vypise pocet oken v dane mistnosti
@param mistnost - mistnost v byte
'''
def vypis_pocet_oken(mistnost):
    pocet = znalosti.zjisti_pocet_oken(mistnost)
    print("---------------------------")
    print("Počet oken v místnosti - {0}: {1}".format(mistnost, pocet))
    print("---------------------------\n")


'''
Funkce vypise kam se dostanu z dane mistnosti
@param mistnost - mistnost v byte
'''
def vypis_kam_se_dostanu(mistnost):
    kam = znalosti.kam_se_dostanu(mistnost)
    print("---------------------------")
    print("Z místnosti - {0}, se dostanu do:".format(mistnost))
    print("---------------------------")
    for x in kam:
        print("- " + x)
    print("---------------------------\n")


'''
Funkce vypise info o oknech v dane mistnosti
@param mistnost - mistnost v byte
'''
def vypis_info_okna(mistnost):
    okna = znalosti.zjisti_okna_v_mistnosti(mistnost)
    i = 1
    if len(okna) == 0:
        print("---------------------------")
        print("V místnosti - {0} nejsou okna".format(mistnost))
        print("---------------------------\n")
    else:
        for x in okna:
            print("---------------------------")
            print("Okno " + str(i))
            for key, value in x.items():
                if key == "is-a":
                    continue
                print(" - " + key + ": " + value)
            i = i + 1
            print("---------------------------")
        print("\n")


'''
Funkce vypise info o dverich v dane mistnosti
@param mistnost - mistnost v byte
'''
def vypis_info_dvere(mistnost):
    dvere = znalosti.zjisti_dvere_v_mistnosti(mistnost)
    i = 1
    if len(dvere) == 0:
        print("---------------------------")
        print("V místnosti - {0} nejsou okna".format(mistnost))
        print("---------------------------\n")
    else:
        for x in dvere:
            print("---------------------------")
            print("Dveře " + str(i))
            for key, value in x.items():
                if key == "is-a":
                    for y in value:
                        if y != mistnost:
                            print("- vedou do místnosti: " + y)
                    continue
                print("- " + key + ": " + value)
            i = i + 1
            print("---------------------------")
        print("\n")
