"""
@author Vitaliy Bohera
@version 1
@info Baze znalosti systemu pro reprezentaci rozložení a vybavení bytu
@date 10.11.2023
"""
import data


'''
Funkce ziska info o byte
@return info - info o byte
'''
def info_byt():
    info = {}
    for key, value in data.byt.items():
        if key == "místnosti" or key == "is-a":
            continue
        info[key] = value
    return info


'''
Funkce ziska info o dane mistnosti
@param mistnost - mistnost v byte
@return info - info o mistnosti
'''
def info_mistnost(mistnost):
    ramec_mistnost = {}
    for key, value in data.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnost = value
            break
    info = {}
    for key, value in ramec_mistnost.items():
        if key == "okna" or key == "is-a" or key == "nábytek" or key == "dveře":
            continue
        info[key] = value
    return info


'''
Funkce ziska vsechny mistnosti v byte
@return mistnosti - mistnosti v byte
'''
def mistnosti_byt():
    mistnosti = []
    for key, value in data.byt.items():
        if key == "místnosti":
            for key2, value2 in value.items():
                mistnosti.append(key2)
    return mistnosti


'''
Funkce zjisti nabytek v mistnosti
@param mistnost - mistnost v byte
@return value - seznam nabytku v mistnosti
'''
def zjisti_nabytek(mistnost):
    ramec_mistnost = {}
    for key, value in data.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnost = value
            break
    for key, value in ramec_mistnost.items():
        if key == "nábytek":
            return value


'''
Funkce zjisti pocet oken v mistnosti
@param mistnost - mistnost v byte
@return - pocet oken v mistnosti
'''
def zjisti_pocet_oken(mistnost):
    ramec_mistnost = {}
    for key, value in data.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnost = value
            break

    for key, value in ramec_mistnost.items():
        if key == "okna":
            return len(value)


'''
Funkce zjisti kam se dostanu z dane mistnosti 
@param mistnost - mistnost v byte
@return result - seznam mistnosti kam se dostanu
'''
def kam_se_dostanu(mistnost):
    ramec_mistnost = {}
    for key, value in data.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnost = value
            break

    result = []

    for key, value in ramec_mistnost.items():
        if key == "dveře":
            for dvere in value:
                for kam in dvere["is-a"]:
                    if kam != mistnost:
                        result.append(kam)
    return result


'''
Funkce zjisti okne v dane mistnosi
@param mistnost - mistnost v byte
@return value - seznam oken v mistnosti'''
def zjisti_okna_v_mistnosti(mistnost):
    ramec_mistnost = {}
    for key, value in data.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnost = value
            break

    for key, value in ramec_mistnost.items():
        if key == "okna":
            return value


'''
Funkce zjisti dvere v dane mistnosti
@param mistnost - mistnost v byte 
@return value - seznam dveri v mistnosti'''
def zjisti_dvere_v_mistnosti(mistnost):
    ramec_mistnost = {}
    for key, value in data.byt["místnosti"].items():
        if key == mistnost:
            ramec_mistnost = value
            break

    for key, value in ramec_mistnost.items():
        if key == "dveře":
            return value
